use strict;
use Jcode;
use Finance::NikkeiQuote;
use Spreadsheet::WriteExcel;
sub LocaltimeExcel($$$$$$;$$);

#1. Ж25Ԃ̊擾
use constant CmpCode => 6758;
my $oCmp = Finance::NikkeiQuote->new(CmpCode);
my $sName = ($oCmp->getinfo)[0];
my $raStock = $oCmp->getrange25();

#2. WriteExcel쐬
#2.1 WorkbookǉAΏۂ̃[NV[gI
my $oBook = Spreadsheet::WriteExcel->new('perl2.xls');
my $oWkS   = $oBook->addworksheet();

#2.2 񕝂ݒ
$oWkS->set_column(0, 0,  5.57);
$oWkS->set_column(1, 4,  5.57);
$oWkS->set_column(5, 5,  9.43);
$oWkS->set_column(6, 6, 16.57);

#2.3 ftHg̏쐬
my $oFmtJpn  = $oBook->addformat();
$oFmtJpn->set_font(jcode('MS PSVbN')->sjis);
$oFmtJpn->set_size(11);
    
#3. ^Cg̐ݒĩZɒlݒj
#3.1 쐬
my $oFmtTtl  = $oBook->addformat();
my $oFmtName = $oBook->addformat();
my $oFmtDate = $oBook->addformat();
$oFmtTtl->copy($oFmtJpn);
$oFmtName->copy($oFmtJpn);
$oFmtDate->copy($oFmtJpn);
$oFmtTtl->set_size(16);
$oFmtName->set_size(14);
$oFmtDate->set_num_format('yyyy/m/d h:mm');

#3.2 f[^ݒ
$oWkS->write(0, 0, jcode('ŋ25Ԃ̊')->sjis, $oFmtTtl);
#3.2.1 tf[^͐lŐݒ肷
my @aDate = localtime;
$oWkS->write_number(0, 6,   
    LocaltimeExcel($aDate[0],$aDate[1],$aDate[2], $aDate[3],$aDate[4],$aDate[5]),
    $oFmtDate);
$oWkS->write(1, 0,  jcode($sName)->sjis, $oFmtName);

#4. \o
#4.1 쐬
my $oFmtHead = $oBook->addformat();
$oFmtHead->copy($oFmtJpn);
$oFmtHead->set_border(1);
$oFmtHead->set_bottom(6);
$oFmtHead->set_align('center');
$oFmtHead->set_fg_color(22);
$oFmtHead->set_pattern(1);

#4.2 lݒ
my $iCol = 0;
foreach my $sTxt ('t', 'n l', ' l', ' l', 'I l',  '') {
    $oWkS->write(2, $iCol,  jcode($sTxt)->sjis, $oFmtHead);
    ++$iCol;
}

#5. f[^̐ݒ
#5.1 쐬
my $oFmtDay = $oBook->addformat();
my $oFmtNum = $oBook->addformat();
$oFmtDay->copy($oFmtJpn);
$oFmtNum->copy($oFmtJpn);
$oFmtDay->set_num_format('m/dd');
$oFmtDay->set_border(1);
$oFmtNum->set_num_format('#,##0');
$oFmtNum->set_border(1);

#5.2 f[^ݒ
for(my $iDay = 0; $iDay <=$#$raStock;$iDay++) {
    my $raData = $raStock->[$iDay];
    my($iM, $iD) = split('/', $raData->[0]);
#5.2.1 t̐ݒiO傫ΑONƔj
    if($iM <= ($aDate[4]+1)) {
        $oWkS->write_number($iDay+3, 0, 
                LocaltimeExcel(0, 0, 0, $iD, $iM - 1, $aDate[5]), 
                $oFmtDay);
    }
    else {
        $oWkS->write_number($iDay+3, 0, 
                LocaltimeExcel(0, 0, 0, $iD, $iM - 1, $aDate[5]-1), 
                $oFmtDay);
    }
#5.2.2 l̐ݒ
    for(my $iCol = 1; $iCol <=$#$raData;$iCol++) {
        $oWkS->write($iDay+3, $iCol,    $raData->[$iCol],  $oFmtNum);
    }
}
#----------------------------------------------------------------------------
# [N
#----------------------------------------------------------------------------
sub LeapYear($) {
    my($iYear)=@_;
    return 1 if($iYear==1900); #Special for Excel
    return ((($iYear % 4)==0) && (($iYear % 100) || ($iYear % 400)==0))? 1: 0;
}
#----------------------------------------------------------------------------
# Excel̎ւ̕ϊilocaltime̔΁{j
#----------------------------------------------------------------------------
sub LocaltimeExcel($$$$$$;$$) {
    my($iSec, $iMin, $iHour, $iDay, $iMon, $iYear, $iMSec, $flg1904) = @_;

#0. Init
    $iMon++;
    $iYear+=1900;

#1. Calc Time
    my $iTime;
    $iTime =$iHour;
    $iTime *=60;
    $iTime +=$iMin;
    $iTime *=60;
    $iTime +=$iSec;
    $iTime += $iMSec/1000.0 if(defined($iMSec)) ;
    $iTime /= 86400.0;      #3600*24(1day in seconds)
    my $iY;
    my $iYDays;

#2. Calc Days
    if($flg1904) {
        $iY = 1904;
        $iTime--;         #Start from Jan 1st
        $iYDays = 366;
    }
    else {
        $iY = 1900;
        $iYDays = 366;  #In Excel 1900 is leap year (That's not TRUE!)
    }
    while($iY<$iYear) {
        $iTime += $iYDays;
        $iY++;
        $iYDays = (LeapYear($iY))? 366: 365;
    }
    for(my $iM=1;$iM < $iMon; $iM++){
        if($iM == 1 || $iM == 3 || $iM == 5 || $iM == 7 || $iM == 8
            || $iM == 10 || $iM == 12) {
            $iTime += 31;
        }
        elsif($iM == 4 || $iM == 6 || $iM == 9 || $iM == 11) {
            $iTime += 30;
        }
        elsif($iM == 2) {
            $iTime += (LeapYear($iYear))? 29: 28;
        }
    }
    $iTime+=$iDay;
    return $iTime;
}
