use strict;
use Jcode;
use Finance::NikkeiQuote;
use GD::Graph::mixed;
use GD::Graph::candle;
#TrueTypetHgEt@CiNTł'c:/WINNT/FONTS/MSGOTHIC.TTC'Ȃǁj
use constant TtfFontFile => '/usr/share/fonts/TrueType/tchagom.ttc';

#1. Ж25Ԃ̊擾
use constant CmpCode => 6758;
my $oCmp = Finance::NikkeiQuote->new(CmpCode);
my $sName = ($oCmp->getinfo)[0];
my $raStock = $oCmp->getrange25();

#2. f[^𕪉
my (@aLbl, @aDt4, @aVol);
foreach my $raData (@$raStock) {
    unshift @aLbl,  shift @$raData;     #o
    unshift @aVol,  pop @$raData;       #
    unshift @aDt4,  $raData;            #e퐔l
}

#3. E\NOt̍쐬
#3.1 ݒ
my $oGraph = GD::Graph::candle->new(800, 400);
$oGraph->set_title_font(TtfFontFile, 12);
$oGraph->set( 
    bgclr       => 'white',
    transparent => 0,
    dclrs       => ['black'],
    title       => jcode($sName)->utf8,
    boxclr      => 'lgray',
    bar_spacing => 10,
  );
#3.2 o
open(PNG, ">candle.png");
binmode(PNG);
eval {
    print PNG $oGraph->plot([\@aLbl, \@aDt4])->png;
};
print STDERR "$@\n" , $oGraph->error, "\n" if($@);
close PNG;

#4. Ot̍쐬
#4.1 ݒ
$oGraph = GD::Graph::mixed->new(800, 400);
$oGraph->set_title_font(TtfFontFile, 12);
$oGraph->set( 
    bgclr        => 'white',
    transparent  => 0,
    two_axes     => 1,
    not_cross    => 1,
    types        => [ 'bars',   'candle' ],
    dclrs        => [ 'cyan', 'black' ],
    title        => jcode($sName)->utf8,
    y1_min_value => 0,
    y1_max_value => 4_000_000,
    y2_min_value => 7_400,
    y2_max_value => 9_400,
    y_long_ticks => 1,
    bar_spacing  => 10,
    boxclr       => 'lgray',
  );
#4.2 o
open(PNG, ">mix.png");
binmode(PNG);
eval {
    print PNG $oGraph->plot([\@aLbl, \@aVol, \@aDt4])->png;
};
print STDERR "$@\n" , $oGraph->error, "\n" if($@);
close PNG;
